${SegmentFile}

Var FirstRun

${SegmentInit}

	${IfNot} ${FileExists} $EXEDIR\Data\settings
		StrCpy $FirstRun 1
	${EndIf}

!macroend

${SegmentPrePrimary}

	${If} $FirstRun = 1

		ReadINIStr $0 $AppDirectory\AppInfo\appinfo.ini Version PackageVersion
		StrCpy $1 $0 4
		WriteINIStr $DataDirectory\mp3directcut\mp3DirectCut.ini mp3DirectCut version $1

		${If} ${FileExists} $CurrentDrive\Documents\Music
			StrCpy $0 $CurrentDrive\Documents\Music
		${Else}
			StrCpy $0 $CurrentDrive
		${EndIf}
		WriteINIStr $DataDirectory\mp3directcut\mp3DirectCut.ini mp3DirectCut file_savepath $0

		${If} ${FileExists} $AppDirectory\mp3DirectCut\mpglib.dll
			WriteINIStr $DataDirectory\mp3directcut\mp3DirectCut.ini mp3DirectCut use_mpglib 1
		${EndIf}

		${If} ${FileExists} $AppDirectory\mp3DirectCut\lame_enc.dll
			WriteINIStr $DataDirectory\mp3directcut\mp3DirectCut.ini mp3DirectCut enc_type 2
		${EndIf}

	${EndIf}

	StrCpy $0 '00'
	${IfNot} $LastDirectory == ""
		${registry::StrToHex} '$LastDirectory' $1
			StrLen $2 $1
			${Do}
				StrCpy $3 $1 2 -$2
				IntOp $2 $2 - 2
				StrCpy $4 $3$0
				StrCpy $5 $5$4
			${LoopUntil} $2 == 0
		${SetEnvironmentVariable} PAL:LastPackagePartialDir:Hex $5
			StrCpy $4 ''
			StrCpy $5 ''
	${EndIf}
	${registry::StrToHex} '$CurrentDirectory' $1
		StrLen $2 $1
		${Do}
			StrCpy $3 $1 2 -$2
			IntOp $2 $2 - 2
			StrCpy $4 $3$0
			StrCpy $5 $5$4
		${LoopUntil} $2 == 0
	${SetEnvironmentVariable} PAL:PackagePartialDir:Hex $5
		StrCpy $4 ''
		StrCpy $5 ''

	${IfNot} $LastPortableAppsBaseDirectory == ""
		${registry::StrToHex} '$LastPortableAppsBaseDirectory' $1
			StrLen $2 $1
			${Do}
				StrCpy $3 $1 2 -$2
				IntOp $2 $2 - 2
				StrCpy $4 $3$0
				StrCpy $5 $5$4
			${LoopUntil} $2 == 0
		${SetEnvironmentVariable} PAL:LastPortableAppsBaseDir:Hex $5
			StrCpy $4 ''
			StrCpy $5 ''
	${EndIf}
	${registry::StrToHex} '$PortableAppsBaseDirectory' $1
		StrLen $2 $1
		${Do}
			StrCpy $3 $1 2 -$2
			IntOp $2 $2 - 2
			StrCpy $4 $3$0
			StrCpy $5 $5$4
		${LoopUntil} $2 == 0
    ${SetEnvironmentVariable} PAL:PortableAppsBaseDir:Hex $5
		StrCpy $4 ''
		StrCpy $5 ''

	${IfNot} $LastDrive == ""
		${registry::StrToHex} '$LastDrive' $1
			StrLen $2 $1
			${Do}
				StrCpy $3 $1 2 -$2
				IntOp $2 $2 - 2
				StrCpy $4 $3$0
				StrCpy $5 $5$4
			${LoopUntil} $2 == 0
		${SetEnvironmentVariable} PAL:LastDrive:Hex $5
			StrCpy $4 ''
			StrCpy $5 ''
	${EndIf}
	${registry::StrToHex} '$CurrentDrive' $1
		StrLen $2 $1
		${Do}
			StrCpy $3 $1 2 -$2
			IntOp $2 $2 - 2
			StrCpy $4 $3$0
			StrCpy $5 $5$4
		${LoopUntil} $2 == 0
    ${SetEnvironmentVariable} PAL:Drive:Hex $5
		StrCpy $4 ''
		StrCpy $5 ''

!macroend
